// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICORE_PARAMETER_TYPE_H_INCLUDED
#define YAMICORE_PARAMETER_TYPE_H_INCLUDED

namespace yami
{

namespace core
{

/// Type of parameter entry.
enum parameter_type
{
    unused,                 ///< Internal mark for unused slots
    boolean,                ///< bool
    integer,                ///< int
    long_long,              ///< long long
    word,                   ///< unsigned int
    long_long_word,         ///< unsigned long long
    double_float,           ///< double
    string,                 ///< string
    binary,                 ///< Binary block
    boolean_array,          ///< Array of bool
    integer_array,          ///< Array of int
    long_long_array,        ///< Array of long long
    word_array,             ///< Array of unsigned int
    long_long_word_array,   ///< Array of unsigned long long
    double_float_array,     ///< Array of double
    string_array,           ///< Array of strings
    binary_array,           ///< Array of binary blocks
    nested_parameters,      ///< Nested parameters object
    nested_parameters_array ///< Array of nested parameters object
};

} // namespace core

} // namespace yami

#endif // YAMICORE_PARAMETER_TYPE_H_INCLUDED
