// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICPP_OUTGOING_MESSAGE_GENERIC_DISPATCHER_H_INCLUDED
#define YAMICPP_OUTGOING_MESSAGE_GENERIC_DISPATCHER_H_INCLUDED

#include "outgoing_message_dispatcher_base.h"
#include <yami4-core/dll.h>

namespace yami
{

class outgoing_message;

namespace details
{

template <typename functor>
class DLL outgoing_message_generic_dispatcher
    : public outgoing_message_dispatcher_base
{
public:
    outgoing_message_generic_dispatcher(functor & f) : f_(f) {}

    virtual void dispatch(outgoing_message & om)
    {
        f_(om);
    }

private:
    functor & f_;
};

} // namespace details

} // namespace yami

#endif // YAMICPP_OUTGOING_MESSAGE_GENERIC_DISPATCHER_H_INCLUDED
