// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICPP_VALUE_PUBLISHER_OVERFLOW_ACTION_H_INCLUDED
#define YAMICPP_VALUE_PUBLISHER_OVERFLOW_ACTION_H_INCLUDED

namespace yami
{

/// User-defined reaction to the overflow condition in value publisher.
enum value_publisher_overflow_action
{
    /// block and wait until previous message is transmitted
    wait_for_previous_message,

    /// abandon the current message and continue with other subscribers
    abandon_message,

    /// abandon the overflowing subscription altogether
    /// and continue with other subscribers
    abandon_subscription
};

} // namespace yami

#endif // YAMICPP_VALUE_PUBLISHER_OVERFLOW_ACTION_H_INCLUDED
